/* PIC16C71(PIC16C6X & PIC16C7X)
/* BY Y.IKUSHIMA
/*
/* X'TAL=4.9152MHz
/*
/* Pj݊ɃfP[uڑ
/* QjdAʐM\tgグ
/*     {[[g1200bpsAXON/XOFFgpAWrbgApeB
/* Rj'P'ɑA0x0DR[hi^[j𑗂ƁA݊킪쓮
/*     'PIC16C71 Writer''Load OK'Ԃ
/* SjŉL̃tH[}bgŏ݃f[^𑗂ƁA݂Jn
/*     B
/*     'R'R[h𑗂
/*       vOp EPROM  0000h-03FFhԒnɋLĂeA
/*       Ce HEXtH[}bgŏo͂܂B
/*     'S'R[h𑗂
/*       vOp EPROM  0000h-07FFhԒnɋLĂeA
/*       Ce HEXtH[}bgŏo͂܂B
/*     'T'R[h𑗂
/*       vOp EPROM  0000h-0FFFhԒnɋLĂeA
/*       Ce HEXtH[}bgŏo͂܂B
/* TjOL̑삪IƁAĂ'PIC16C71 Writer''Load OK'ԂASj
/*     삪\ƂȂ
/* Uj݃G[ƁA'Write ERROR'Ԃ
/*
/* f[^tH[}bgiCegdwtH[}bgj--------------------
/*
/* if[^ER[hj
/* @tB[h@e
/* --------------------------------------------------------------
/*   P    RECD MARK     ":"(0x3A)
/*   Q    REC LEN       f[^EtB[h̑傫ioCgPʁj
/*   S    LOAD ADR      ݃AhX
/*   Q    REC TYP       萔"00"(0x3030)
/*   Q  DATA          oCi[EC[WioCgj
/*   Q    CHK SUM       `FbNT
/*	<----3------->
/*
/*  FPj݃AhX̓oCgPʂŋLqĂ邪Aohb͂P
/*  @@@@PSrbgł邽߂QoCgKvƂB̂߁A
/*    @@@AhX͏L(LOAD ADR)QŊ̂ƂȂ
/*      QjRtB[VWX^̃AhX0x20000x2007Ƃ
/*  @@@@
/*
/* iIER[hj
/* @tB[h@e
/* --------------------------------------------------------------
/*   P    RECD MARK     ":"(0x3A)
/*   Q    REC LEN       萔"00"(0x3030)
/*   S    LOAD ADR      萔"0000"(0x30303030)
/*   Q    REC TYP       萔"01"(0x3031)
/*   Q    CHK SUM       萔"FF"(0x4646)
/*

#CNF	2000	00000000000111	;'7'
#CNF	2001	00000000000001	;'1'
#CNF	2002	00000000000000	;'0'
#CNF	2003	00000000000110	;'6'
#CNF	2007	00000000010001

#DAT	00	0D	;(CR)
#DAT	01	50	;'P'
#DAT	02	49	;'I'
#DAT	03	43	;'C'
#DAT	04	31	;'1'
#DAT	05	36	;'6'
#DAT	06	43	;'C'
#DAT	07	37	;'7'
#DAT	08	31	;'1'
#DAT	09	20	;' '
#DAT	0A	57	;'W'
#DAT	0B	72	;'r'
#DAT	0C	69	;'i'
#DAT	0D	74	;'t'
#DAT	0E	65	;'e'
#DAT	0F	72	;'r'
#DAT	10	0D	;(CR)
#DAT	11	4C	;'L'
#DAT	12	6F	;'o'
#DAT	13	61	;'a'
#DAT	14	64	;'d'
#DAT	15	20	;' '
#DAT	16	4F	;'O'
#DAT	17	4B	;'K'
#DAT	18	0D	;(CR)
#DAT	19	00	;END MARK
#DAT	1A	0D	;(CR)
#DAT	1B	57	;'W'
#DAT	1C	72	;'r'
#DAT	1D	69	;'i'
#DAT	1E	74	;'t'
#DAT	1F	65	;'e'
#DAT	20	20	;' '
#DAT	21	45	;'E'
#DAT	22	52	;'R'
#DAT	23	52	;'R'
#DAT	24	4F	;'O'
#DAT	25	52	;'R'
#DAT	26	0D	;(CR)
#DAT	27	00	;END MARK
#DAT	28	0D	;(CR)
#DAT	29	3A	;':'
#DAT	2A	31	;'1'
#DAT	2B	30	;'0'
#DAT	2C	00	;END MARK
#DAT	2D	0D	;(CR)
#DAT	2E	3A	;':'
#DAT	2F	30	;'0'
#DAT	30	30	;'0'
#DAT	31	30	;'0'
#DAT	32	30	;'0'
#DAT	33	30	;'0'
#DAT	34	30	;'0'
#DAT	35	30	;'0'
#DAT	36	31	;'1'
#DAT	37	46	;'F'
#DAT	38	46	;'F'
#DAT	39	0D	;(CR)
#DAT	3A	00	;END MARK

/* define -------------------------------------------------------------
/* PAGE 0
#DEF	IND0	00
#DEF	TMR0	01
#DEF	PCL	02
#DEF	STATUS	03
#DEF	FSR	04
#DEF	PORTA	05
#DEF	PORTB	06
#DEF	EEDATA	08
#DEF	EEADR	09
#DEF	PCLATH	0A
#DEF	INTCON	0B
/* PAGE 1
#DEF	OPTION	01
#DEF	TRISA	05
#DEF	TRISB	06
#DEF	EECON1	08
#DEF	EECON2	09

/* PORTA AND TRISA BITS
#DEF	RA0	0
#DEF	RA1	1
#DEF	RA2	2
#DEF	RA3	3
#DEF	RA4	4
/* PORTB AND TRISB BITS
#DEF	RB0	0
#DEF	RB1	1
#DEF	RB2	2
#DEF	RB3	3
#DEF	RB4	4
#DEF	RB5	5
#DEF	RB6	6
#DEF	RB7	7
/* STATUS BITS
#DEF	CARY	0
#DEF	ZERO	2
#DEF	RP0	5
/* INTCON BITS
#DEF	GIE	7
#DEF	TOIE	5
#DEF	TOIF	2
/* OPTION BITS
#DEF	PS0	0
#DEF	PS1	1
#DEF	PS2	2
#DEF	PSA	3
#DEF	RTS	5

/* USRE DEF
#DEF	WREG	0
#DEF	BACK	1

/* RAM DEF -----------------------------------------------------------
#DEF	RMODE	0C	;RMODE
#DEF	RCNT	0D	;READ TIMING CNT
#DEF	SMODE	0E	;SMODE
#DEF	RTREG	0F	;READ TMP REG
#DEF	STREG	10	;SEND TMP REG
#DEF	SCNT	11	;SEND TIMING CNT
#DEF	RDBUF0	12	;READ DATA BUF 0
#DEF	RDBUF1	13	;              1
#DEF	RDBUF2	14	;              2
#DEF	RDBUF3	15	;              3
#DEF	RDBUF4	16	;              4
#DEF	RDBUF5	17	;              5
#DEF	RDBUF6	18	;              6
#DEF	RDBUF7	19	;              7
#DEF	SENDC	1A	;SEND CONTROL
/*		RB0	;XOFF MODE 0=OFF , 1=ON
/*		RB1	;CHAR SEND BUSY 0=NOT BUSY , 1=BUSY
/*		RB2	;WRITE 0=COMMAND , 1=DATA
/*		RB3	;SMODE 0=NOT BUSY , 1=BUSY
/*		RB4	;WRITE ERROR 0=NO , 1=YES
/*		RB5	;RDTMP 0=CLR , 1=DATA SET
/*		RB7	:EOF 0=NO , 1=YES
#DEF	TMPREG	1B	;TEMP REG
#DEF	RDTMP	1C	;READ TMP. REG.
#DEF	MMODE	1D	;MAIN MODE
#DEF	STMR0	1E	;TMR0 STORE
#DEF	CSCNT	1F	;CHAR SEND COUNTER
#DEF	ADCNT0	20	;ADDRES COUNTER 0(LOW 8 bit)
#DEF	ADCNT1	21	;               1(HIGH 2bit)
#DEF	RDAD0	22	;READ ADDRES0
#DEF	RDAD1	23	;READ ADDRES1
#DEF	SBYTE0	24	;SEND BYTE0
#DEF	SBYTE1	25	;SEND BYTE1
#DEF	SDBUF	26	;SEND BUF
#DEF	PDCNT	27	;PROGRAMING DL. CNT
#DEF	DLOP	28	;DATA READ LOOP
#DEF	MCON	29	;MODE CONTROL
/*		RB0	;vO݁ij 0=NO,1=YES
/*		RB1	;vO݁ipj 0=NO,1=YES
/*		RB2	;RtBO[V݁ij 0=NO,1=YES
/*		RB3	;RtBO[V݁ipj 0=NO,1=YES
#DEF	CSUM	2A	;CHECK SUM
#DEF	PCNT	2B	;݉
#DEF	PMAX	2C	;
#DEF	APCNT0	2D	;ǉ݉񐔁iʂWrbgj
#DEF	APCNT1	2E	;                iʂWrbgj
#DEF	RADMAX	2F	;ǂݏoŏIAhX

/* LITERAL DEF -------------------------------------------------------
#DEF	SL	04	;10(16)
#DEF	HSL	02	;
#DEF	XOFFC	13	;XOFF CODE(CTRL+S)
#DEF	XONC	11	:XON CODE(CTRL+Q)

#DEF	LCREG	00	;LOAD CONFIGURATION REG.(000000)
#DEF	LDPM	02	;LOAD DATA FOR PROG. MEM.(000010)
#DEF	RDPM	04	;READ DATA FOR PROG. MEM.(000100)
#DEF	INCAD	06	;INCREMENT ADDRESS(000110)
#DEF	BEGINP	08	;BEGIN PROGRAMING(001000)
#DEF	ENDP	0E	;END PROGRAMMING(001110)

#DEF	PRDT	40	;PROGRAMIN DL. TIME(13ms)

/* POWER ON RESET VECTOR
#ORG	0
GOTO	LOP1
NOP
NOP
NOP

/* INTRRUPT VECTOR
GOTO	LOP2

/* BIN -> ASCII TABLE ------------------------------------------------
#LBL	BINASC
ADDWF	PCL,	BACK	;W + PCL -> PCL
RETLW	#30		;'0'
RETLW	#31		;'1'
RETLW	#32		;'2'
RETLW	#33		;'3'
RETLW	#34		;'4'
RETLW	#35		;'5'
RETLW	#36		;'6'
RETLW	#37		;'7'
RETLW	#38		;'8'
RETLW	#39		;'9'
RETLW	#41		;'A'
RETLW	#42		;'B'
RETLW	#43		;'C'
RETLW	#44		;'D'
RETLW	#45		;'E'
RETLW	#46		;'F'

/* RMODE JAMP TABLE --------------------------------------------------
#LBL	RMJMP
ADDWF	PCL,	BACK	;W + PCL -> PCL
/*                      ;RMODE
GOTO	RMODE00		;00	START BIT ҂
GOTO	RMODE01		;01	START BIT mF
GOTO	RMODE02		;02	DATA READ(0bit)
GOTO	RMODE02		;03	DATA READ(1bit)
GOTO	RMODE02		;04	DATA READ(2bit)
GOTO	RMODE02		;05	DATA READ(3bit)
GOTO	RMODE02		;06	DATA READ(4bit)
GOTO	RMODE02		;07	DATA READ(5bit)
GOTO	RMODE02		;08	DATA READ(6bit)
GOTO	RMODE02		;09	DATA READ(7bit)
GOTO	RMODE10		;10	STOP BIT mF

/* SMODE JAMP TABLE --------------------------------------------------
#LBL	SMJMP
ADDWF	PCL,	BACK	;W + PCL -> PCL
/*			;SMODE
GOTO	SMODE00		;00	READ BUF ҂
GOTO	SMODE01		;01	START BIT
GOTO	SMODE02		;02	DATA SEND(0bit)
GOTO	SMODE02		;03	DATA SEND(1bit)
GOTO	SMODE02		;04	DATA SEND(2bit)
GOTO	SMODE02		;05	DATA SEND(3bit)
GOTO	SMODE02		;06	DATA SEND(4bit)
GOTO	SMODE02		;07	DATA SEND(5bit)
GOTO	SMODE02		;08	DATA SEND(6bit)
GOTO	SMODE02		;09	DATA SEND(7bit)
GOTO	SMODE10		;10	STOP BIT
GOTO	SMODE11		;11	SEND END

/* MMODE JAMP TABLE --------------------------------------------------
#LBL	MMJMP
ADDWF	PCL,	BACK	;W + PCL -> PCL
/*			;MMODE
GOTO	MMODE00		;00	INIT (R}h'P'M҂)
GOTO	MMODE01		;01	(CR)R[hM҂
GOTO	MMODE02		;02	(CR)'PIC16C71 Writer'(CR)'LOAD OK'(CR)
/*				LN^[MJE^(CNT)Zbg
GOTO	MMODE03		;03	񑗐M
GOTO	MMODE04		;04	RECOD MARK(':'),
/*				ǂ݂R}h('R','S','T') `FbN
GOTO	MMODE05		;05	REC LEN PڎM
GOTO	MMODE06		;06	        QڎM
GOTO	MMODE07		;07	LOAD ADR PڎM
GOTO	MMODE08		;08	         QڎM
GOTO	MMODE09		;09	         RڎM
GOTO	MMODE0A		;0A	         SڎM
GOTO	MMODE0B		;0B	REC TYPE PڎM
GOTO	MMODE0C		;0C	         QڎM
GOTO	MMODE0D		;0D	vOARtBO[VA
/*				̔
/* PROGRAM COUNTERPROGRAM MEMORY̐擪ɃZbg
GOTO	MMODE0E		;0E	_~[f[^̗p
GOTO	MMODE0F		;0F	LOAD DATA COMMAND
GOTO	MMODE10		;10	f[^ ʂWrbg
GOTO	MMODE11		;11	               ʂWrbg
GOTO	MMODE12		;12	ZbgI
/* PROGRAM COUNTERCONFIG MEMORY̐擪ɃZbg
GOTO	MMODE0E		;13	_~[f[^̗p
GOTO	MMODE14		;14	LOAD CONFIGURATION COMMAND
GOTO	MMODE10		;15	f[^ ʂWrbg
GOTO	MMODE11		;16	               ʂWrbg
GOTO	MMODE17		;17	ZbgI
/*
GOTO	MMODE18		;18	I
/*
GOTO	MMODE19		;19	AhXEXLbv
GOTO	MMODE1A		;1A	DATA PڎM
GOTO	MMODE1B		;1B	     QڎM
GOTO	MMODE1C		;1C	     RڎM
GOTO	MMODE1D		;1D	     SڎM
/* f[^ݏ
GOTO	MMODE1E		;1E	݉񐔂̏
GOTO	MMODE0F		;1F	LOAD DATA COMMAND
GOTO	MMODE10		;20	f[^ ʂWrbg
GOTO	MMODE11		;21	               ʂWrbg
GOTO	MMODE22		;22	BEGGIN / END PROGRAMMING COMMAND
NOP			;23	NOT USE
NOP			;24	NOT USE
GOTO	MMODE25		;25	f[^ǂݍ݃R}h
GOTO	MMODE26		;26	f[^ǂݍ ʂWrbg
GOTO	MMODE27		;27	               ʂWrbg
GOTO	MMODE28		;28	r
/* ǉ
GOTO	MMODE29		;29	ǉ݉񐔂̏
GOTO	MMODE0F		;2A	LOAD DATA COMMAND
GOTO	MMODE10		;2B	f[^ ʂWrbg
GOTO	MMODE11		;2C	               ʂWrbg
GOTO	MMODE22		;2D	BEGGIN / END PROGRAMMING COMMAND
NOP			;2E	NOT USE
NOP			;2F	NOT USE
GOTO	MMODE30		;30	݉񐔃`FbN
/*
GOTO	MMODE31		;31	DLOP`FbN
GOTO	MMODE32		;32	CHK SUM PڎMiej
GOTO	MMODE33		;33	        QڎMiej
GOTO	MMODE01		;34	0x0D(CR)R[hmF
GOTO	MMODE35		;35	̃R[hM
GOTO	MMODE36		;36	DATA pM
GOTO	MMODE01		;37	0x0D(CR)R[hmF
GOTO	MMODE38		;38	f[^I
GOTO	MMODE39		;39	(CR)'Write ERROR'(CR)
/*				LN^[MJE^(CNT)Zbg
GOTO	MMODE03		;3A	񑗐M
GOTO	MMODE31		;3B	DLOP`FbN
/* vOǂ݂
GOTO	MMODE3C		;3C	vOǂ݂
GOTO	MMODE3D		;3D	(CR)':10'
/*				LN^[MJE^(CNT)Zbg
GOTO	MMODE03		;3E	񑗐M
GOTO	MMODE3F		;3F	AhXPڑM
GOTO	MMODE40		;40	AhXQڑM
GOTO	MMODE41		;41	AhXRڑM
GOTO	MMODE42		;42	AhXSڑM
GOTO	MMODE43		;43	'0'M
GOTO	MMODE43		;44	'0'M
GOTO	MMODE45		;45	f[^PڑM
GOTO	MMODE46		;46	f[^QڑM
GOTO	MMODE47		;47	f[^RڑM
GOTO	MMODE48		;48	f[^SڑM
GOTO	MMODE49		;49	`FbNrtlPڑM
GOTO	MMODE4A		;4A	`FbNrtlQڑM
GOTO	MMODE4B		;4B	I
GOTO	MMODE4C		;4C	RtBO[Vǂ݂
GOTO	MMODE3D		;4D	(CR)':10'
/*				LN^[MJE^(CNT)Zbg
GOTO	MMODE03		;4E	񑗐M
GOTO	MMODE3F		;4F	AhXPڑM
GOTO	MMODE40		;50	AhXQڑM
GOTO	MMODE41		;51	AhXRڑM
GOTO	MMODE42		;52	AhXSڑM
GOTO	MMODE43		;53	'0'M
GOTO	MMODE43		;54	'0'M
GOTO	MMODE45		;55	f[^PڑM
GOTO	MMODE46		;56	f[^QڑM
GOTO	MMODE47		;57	f[^RڑM
GOTO	MMODE48		;58	f[^SڑM
GOTO	MMODE49		;59	`FbNrtlPڑM
GOTO	MMODE4A		;5A	`FbNrtlQڑM
GOTO	MMODE5B		;5B	I
GOTO	MMODE5C		;5C	':00000001FF(CR)'
/*				LN^[MJE^(CNT)Zbg
GOTO	MMODE03		;5D	񑗐M
GOTO	MMODE5E		;5E	I

/* MAIN PROGRAM ------------------------------------------------------
#LBL	LOP1

/* PORT RA0 AND RA1 ARE OUTPUT
BSF	STATUS,	RP0	;BANK 1

MOVLW	#F8		;F8=1111 1000 -> W
MOVWF	TRISA		;W -> TRISA
/* BCF	TRISA	RA0	;RA0 IS OUTPUT(CLOCK)
/* BCF	TRISA	RA1	;RA1 IS OUTPUT(DATA)
/* BCF	TRISA	RA2	;RA2 IS OUTPUT(MCLR)
/* BSF	TRISA	RA3	;RA3 IS INPUT
/* BSF	TRISA	RA4	;RA4 IS INPUT

MOVLW	#FD		;FD=1111 1101 -> W
MOVWF	TRISB		;W -> TRISB
/* BSF	TRISB	RB0	;RB0 IS INPUT
/* BCF	TRISB	RB1	;RB1 IS OUTPUT
/* BSF	TRISB	RB2	;RB2 IS INPUT
/* BSF	TRISB	RB3	;RB3 IS INPUT
/* BSF	TRISB	RB4	;RB4 IS INPUT
/* BSF	TRISB	RB5	;RB5 IS INPUT
/* BSF	TRISB	RB6	;RB6 IS INPUT
/* BSF	TRISB	RB7	;RB7 IS INPUT

BCF	STATUS,	RP0	;BANK 0
BSF	PORTB,	RB1	;SD SET

/* PRESCALER AND SIGNAL SOURCE SET
BSF	STATUS,	RP0	;BANK 1
BCF	OPTION,	PS0	;TMR0 RATE 1:2
BCF	OPTION,	PS1
BCF	OPTION,	PS2
BSF	OPTION,	PSA	;PRESCALER ASSIGNMENT IS WDT
BCF	OPTION,	RTS	;TMR0 SIGNAL SOURCE IS CLKOUT
BCF	STATUS,	RP0	;BANK 0

/* INTCON REGISTER SET
CLRF	TMR0		;TMR0 CLR
BCF	INTCON,	TOIF	;TMR INTEERUPT FLAG CLEAR
BSF	INTCON,	TOIE	;TMR0 INTERRUPT ENABLE
BSF	INTCON,	GIE	;GLOBAL INTERRUPT ENABLE

CLRF	PORTA		;PORTA CLR

/* RAM CLR
CLRF	RMODE		;RMODE CLR
CLRF	SMODE		;SMODE CLR
CLRF	RDBUF0		;RDBUF0 CLR
CLRF	RDBUF1		;RDBUF1 CLR
CLRF	RDBUF2		;RDBUF2 CLR
CLRF	RDBUF3		;RDBUF3 CLR
CLRF	RDBUF4		;RDBUF4 CLR
CLRF	RDBUF5		;RDBUF5 CLR
CLRF	RDBUF6		;RDBUF6 CLR
CLRF	RDBUF7		;RDBUF7 CLR
CLRF	SENDC		;SEND CONTROL CLR
CLRF	MMODE		;MMODE CLR
CLRF	SDBUF		;SEND DATA BUF CLR
CLRF	MCON		;MODE CONTROL CLR

/* DUMMY LOP
#LBL	LOP3
NOP
GOTO	LOP3

/* INTERUPT SERVICE -------------------------------------------------
#LBL	LOP2

BCF	INTCON,	TOIF	;TMR0 INTERRUPT FLAG CLEAR

/* RMODE ------------------------------------------------------------
MOVF	RMODE,	WREG	;RMODE	-> W
GOTO	RMJMP		;RMODE JAMP TABLE

/* RMODE == 00 (START BIT ҂) ----------------------------------------
#LBL	RMODE00
BTFSC	PORTB,	RB0	;IF RD.PORT == 0(STOP BIT) THEN SKIP
GOTO	REND		;IF RD.PORT == 1 THEN REND
/* START BIT?
MOVLW	HSL		;HSL -> W
MOVWF	RCNT		;W -> RCNT
GOTO	REND0		;RMODE INC

/* RMODE == 01 (START mF) --------------------------------------------
#LBL	RMODE01
DECFSZ	RCNT,	BACK	;RCNT - 1 -> RCNT , IF RCNT == 0 THEN SKIP
GOTO	REND		;IF RCNT != 0 THEN REND
/* STCNT == 0
BTFSC	PORTB,	RB0	;IF RD.PORT == 0(START BIT) THEN SKIP
GOTO	RMODE0101	;IF RD.PORT == 1(ERROR) THEN RMODE0101
/* START BIT OK
MOVLW	SL		;SL -> W
MOVWF	RCNT		;W -> RCNT
CLRF	RTREG		;RTREG CLR
GOTO	REND0		;RMODE INC
/* START BIT NG
#LBL	RMODE0101
CLRF	RMODE		;RMODE=00
GOTO	REND

/* RMODE == 02 TO 09 (DATA READ 0bit TO 7bit) --------------------------
#LBL	RMODE02
DECFSZ	RCNT,	BACK	;RCNT - 1 -> RCNT , IF RCNT == 0 THEN SKIP
GOTO	REND		;IF RCNT != 0 THEN REND
/* RCNT == 0
BCF	STATUS,	CARY	;C bit CLR
BTFSC	PORTB,	RB0	;IF RD.PORT == 0 THEN SKIP
BSF	STATUS,	CARY	;C bit SET
RRF	RTREG,	BACK	;C -> RTREG<7>,RTREG<n> -> RTREG<n-1>,RTREG<7> -> C
MOVLW	SL		;SL -> W
MOVWF	RCNT		;W -> RCNT
GOTO	REND0		;RMODE INC

/* RMODE == 10 (STOP BIT mF) -----------------------------------------
#LBL	RMODE10
DECFSZ	RCNT,	BACK	;RCNT - 1 -> RCNT , IF RCNT == 0 THEN SKIP
GOTO	REND		;IF RCNT != 0 THEN REND
/* RCNT == 0
BTFSS	PORTB,	RB0	;IF RD.PORT == 1(STOP BIT OK) THEN SKIP
GOTO	RMODE1001	;IF RD.PORT == 0(STOP BIT NG) THEN RMODE1001
/* STOP BIT OK
/* RTREG CHECK
MOVF	RTREG,	WREG	;RTREG CHECK
BTFSC	STATUS,	ZERO	;IF RTREG != 0 THEN SKIP
GOTO	RMODE1001	;IF RTREG == 0 THEN RMODE1001
/* RTREG != 0
CALL	BUFPUT		;W(RTREG) -> RDBUF
/* STOP BIT NG
#LBL	RMODE1001
CLRF	RMODE
GOTO	REND

#LBL	REND0		;RMODE INC
INCF	RMODE,	BACK	;RMODE + 1 -> RMODE
#LBL	REND
/* SMODE ------------------------------------------------------------
MOVF	SMODE,	WREG	;SMODE	-> W
GOTO	SMJMP		;SMODE JAMP TABLE

/* SMODE == 00 (START BIT ҂) ----------------------------------------
#LBL	SMODE00
MOVF	SDBUF,	WREG	;SDBUF -> W
BTFSC	STATUS,	ZERO	;IF SDBUF != 0(DATA) THEN SKIP
GOTO	SEND		;IF SDBUF == 0(NOT DATA) THEN SEND
/* START BIT
MOVWF	STREG		;W -> STREG
BSF	SENDC,	RB3	;SMODE BUSY=1(BUSY)
CLRF	SDBUF		;SDBUF CLR
GOTO	SEND0		;SMODE INC

/* SMODE == 01 (START BIT) ---------------------------------------------
#LBL	SMODE01
BCF	PORTB,	RB1	;SD PORT CLR(STOP BIT)
MOVLW	SL		;SL -> W
MOVWF	SCNT		;W -> SCNT
GOTO	SEND0		;SMODE INC

/* SMODE == 02 TO 09 (DATA READ 0 TO 7 bit) ----------------------------
#LBL	SMODE02
DECFSZ	SCNT,	BACK	;SCNT - 1 -> SCNT , IF SCNT == 0 THEN SKIP
GOTO	SEND		;IF SCNT != 0 THEN SEND
/* SCNT == 0
RRF	STREG,	BACK	;STREG<0> -> C
BTFSC	STATUS,	CARY	;IF C == 0 THEN SKIP
BSF	PORTB,	RB1	;IF C == 1 THEN SD=1
BTFSS	STATUS,	CARY	;IF C == 1 THEN SKIP
BCF	PORTB,	RB1	;IF C == 0 THEN SD=0
MOVLW	SL		;SL -> W
MOVWF	SCNT		;W -> SCNT
GOTO	SEND0		;SMODE INC

/* SMODE == 10 (STOP BIT ON) ------------------------------------------
#LBL	SMODE10
DECFSZ	SCNT,	BACK	;SCNT - 1 -> SCNT , IF SCNT == 0 THEN SKIP
GOTO	SEND		;IF SCNT != 0 THEN SEND
/* SCNT == 0
BSF	PORTB,	RB1	;SD = 1(STOP BIT)
MOVLW	SL		;SL -> W
MOVWF	SCNT		;W -> SCNT
GOTO	SEND0		;SMODE INC

/* SMODE == 11 (SEND END) ---------------------------------------------
#LBL	SMODE11
DECFSZ	SCNT,	BACK	;SCNT - 1 -> SCNT , IF SCNT == 0 THEN SKIP
GOTO	SEND		;IF SCNT != 0 THEN SEND
/* SCNT == 0
CLRF	SMODE		;SMODE CLR
BCF	SENDC,	RB3	;SMODE BUSY=0(NOT BUSY)
GOTO	SEND

#LBL	SEND0		;SMODE INC
INCF	SMODE,	BACK	;SMODE + 1 -> SMODE
#LBL	SEND
/* MMODE -------------------------------------------------------------
/* SMODE BUSY `FbN
BTFSC	SENDC,	RB3	;IF SMODE == 0(NOT BUSY) THEN SKIP
GOTO	MEND10		;IF SMODE == 1(BUSY) THEN MEND10(NOT CLR,NOT INC)
/* SMODE == NOT BUSY
BTFSC	SENDC,	RB5	;IF RDTMP == 0(CLR) THEN SKIP
GOTO	RDNCLR		;IF RDTMP != 0(NOT CLR ) THEN RDNCLR
/* RDTMP == CLR
CALL	BUFGET		;RDBUF -> W
MOVWF	RDTMP		;W -> RDTMP
BSF	SENDC,	RB5	;RDTMP NOT CLR(DATA SET)
/* XOFF/XON R[h`FbN
SUBLW	XOFFC		;XOFFC - W -> W
BTFSS	STATUS,	ZERO	;IF W == XOFFC THEN SKIP
GOTO	NXOFF		;IF W != XOFFC THEN NXOFF
/* XOFFC == RDTMP
#LBL	XOFON
MOVF	RDTMP,	WREG	;RDTMP -> W
MOVWF	SDBUF		;W -> SDBUF
GOTO	MEND00		;CLR,NOT INC
/* XOFFC != RDTMP
#LBL	NXOFF
MOVF	RDTMP,	WREG	;RDTMP -> W
SUBLW	XONC		;XONC - W -> W
BTFSC	STATUS,	ZERO	;IF RDTMP != XONC THEN SKIP
GOTO	XOFON		;IF RDTMP == XONC THEN XOFON
/* RDTMP != XOFFC OR XONC
#LBL	RDNCLR
MOVF	MMODE,	WREG	;MMODE	-> W
GOTO	MMJMP		;MMODE JAMP TABLE

/* MMODE == 00	INIT (R}h'P'҂) -----------------------------
#LBL	MMODE00
MOVF	RDTMP,	WREG	;RDTMP -> W
SUBLW	#50		;50('P') - W -> W
BTFSS	STATUS,	ZERO	;IF RDTMP == 50('P') THEN SKIP
GOTO	MEND00		;IF RDTMP != 50('P') THEN MEND00(CLR,NOT INC)
/* RDTMP == 50('P')
GOTO	MEND01		;CLR,INC

/* MMODE == 01 (CR)R[h҂ ----------------------------------------
#LBL	MMODE01
MOVF	RDTMP,	WREG	;RDTMP -> W
SUBLW	#0D		;0D(CR) - W -> W
BTFSS	STATUS,	ZERO	;IF RDTMP == 0D(CR) THEN SKIP
/* RDTMP != 0D(CR)
GOTO	MEND00		;CLR,NOT INC
/* RDTMP == 0D
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 02 (CR)'PIC16C71 Writer'(CR)'LOAD OK'(CR) ----------------
/*				LN^[MJE^(CNT)Zbg
#LBL	MMODE02
BCF	PORTA,	RA2	;+12V OFF
MOVLW	#00		;00 -> W
MOVWF	CSCNT		;W -> CHAR SEND CNT
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 03 񑗐M --------------------------------------------
#LBL	MMODE03
MOVF	CSCNT,	WREG	;CSCNT -> W
MOVWF	EEADR		:W -> EEADR
BSF	STATUS,	RP0	;BANK 1
BSF	EECON1,	RB0	;EECON1<0>=1(RD)
BCF	STATUS,	RP0	;BANK 0
MOVF	EEDATA,	WREG	;EEDATA -> W
BTFSC	STATUS,	ZERO	;IF W != 0 THEN SKIP
GOTO	MEND11		;IF W == 0 THEN MEND11(NOT CLR,INC)
INCF	CSCNT,	BACK	;CSCNT + 1 -> CSCNT
MOVWF	SDBUF		;W -> SDBUF
GOTO	MEND10		;NOT CLR,NOT INC

/* MMODE == 04 RECOD MARK(':') ---------------------------------------
/*				ǂ݂R}h('R','S','T') `FbN
#LBL	MMODE04
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
SUBLW	#3A		;3A(':') - W -> W
BTFSS	STATUS,	ZERO	;IF RDTMP == 3A(':') THEN SKIP
GOTO	MMODE0401	;IF RDTMP != 3A(':') THEN MMODE0401
/* RDTMP == 3A(':')
BCF	SENDC,	RB7	;EOF=0(NO)
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF
/* RDTMP != 3A(':')
#LBL	MMODE0401
MOVF	RDTMP,	WREG	;RDTMP -> W
SUBLW	#52		;52('R') - W -> W
BTFSS	STATUS,	ZERO	;IF RDTMP == 52('R') THEN SKIP
GOTO	MMODE0402	;IF RDTMP != 52('R') THEN MMODE0402
/* RDTMP == 52('R')
MOVLW	#08		;08 -> W
MOVWF	RADMAX		;W -> RADMAX
MOVLW	#3C		;3C -> W
GOTO	MEND04		;CLR,LOAD,RDTMP -> SDBUF
/* RDTMP != 52('R')
#LBL	MMODE0402
MOVF	RDTMP,	WREG	;RDTMP -> W
SUBLW	#53		;53('S') - W -> W
BTFSS	STATUS,	ZERO	;IF RDTMP == 53('S') THEN SKIP
GOTO	MMODE0403	;IF RDTMP != 53('S') THEN MMODE0403
/* RDTMP == 53('S')
MOVLW	#10		;10 -> W
MOVWF	RADMAX		;W -> RADMAX
MOVLW	#3C		;3C -> W
GOTO	MEND04		;CLR,LOAD,RDTMP -> SDBUF
/* RDTMP != 53('S')
#LBL	MMODE0403
MOVF	RDTMP,	WREG	;RDTMP -> W
SUBLW	#54		;54('T') - W -> W
BTFSS	STATUS,	ZERO	;IF RDTMP == 54('T') THEN SKIP
GOTO	MEND00		;IF RDTMP != 54('T') THEN MEND00(CLR,NOT INC)
/* RDTMP == 54('T')
MOVLW	#20		;20 -> W
MOVWF	RADMAX		;W -> RADMAX
MOVLW	#3C		;3C -> W
GOTO	MEND04		;CLR,LOAD,RDTMP -> SDBUF

/* MMODE == 05 REC LEN PڎM --------------------------------
#LBL	MMODE05
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
MOVWF	DLOP		;W -> DLOP
SWAPF	DLOP,	BACK	;DLOP<3:0> -> DLOP<7:4>,DLOP<7:4> -> DLOP<3:0>
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 06 REC LEN QڎM --------------------------------
#LBL	MMODE06
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
IORWF	DLOP,	BACK	;DLOP OR W -> DLOP
/* QŊ
BCF	STATUS,	CARY	;CARY CLR
RRF	DLOP,	BACK	;CARY -> DLOP<7>,DLOP<0> -> CARY
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 07 LOAD ADR PڎM ---------------------------------
#LBL	MMODE07
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
MOVWF	RDAD1		;W -> RDAD1
SWAPF	RDAD1,	BACK	;RDAD1<3:0> -> RDAD1<7:4>,RDAD1<7:4> -> RDAD1<3:0>
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 08 LOAD ADR QڎM --------------------------------
#LBL	MMODE08
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
IORWF	RDAD1,	BACK	;RDAD1 OR W -> RDAD1
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 09 LOAD ADR RڎM ---------------------------------
#LBL	MMODE09
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
MOVWF	RDAD0		;W -> RDAD0
SWAPF	RDAD0,	BACK	;RDAD0<3:0> -> RDAD0<7:4>,RDAD0<7:4> -> RDAD0<3:0>
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 0A LOAD ADR SڎM --------------------------------
#LBL	MMODE0A
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
IORWF	RDAD0,	BACK	;RDAD0 OR W -> RDAD0
/* AhXϊiQŊj
BCF	STATUS,	CARY	;CARY CLR
RRF	RDAD1,	BACK	;CARY -> RDAD1<7> ,RDAD1<n+1> -> RDAD1<n> 
/*			;,RDAD1<0> -> CARY
RRF	RDAD0,	BACK	;CARY -> RDAD0<7> ,RDAD0<n+1> -> RDAD0<n> 
/*			;,RDAD0<0> -> CARY
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 0B REC TYPE PڎM --------------------------------
#LBL	MMODE0B
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 0C REC TYPE QڎM --------------------------------
#LBL	MMODE0C
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
MOVWF	SDBUF		;W -> SDBUF
SUBLW	#31		;31('1') - W -> W
BTFSS	STATUS,	ZERO	;IF RDTMP == 31('1') THEN SKIP
GOTO	MEND01		;IF RDTMP != 31('1') THEN MEND01(CLR,INC)
/* RDTMP == 31
BSF	SENDC,	RB7	;EOF=1(YES)
MOVLW	#18		;18 -> W
GOTO	MEND02		;CLR,LOAD

/* MMODE == 0D vOARtBO[VA---------
/*				̔
#LBL	MMODE0D
/* AhX`FbN
MOVF	RDAD1,	WREG	;RDAD1 -> WREG
SUBLW	#20		;20 - W -> W
BTFSS	STATUS,	ZERO	;IF RDAD1 == 20(RtBO[V) THEN SKIP
GOTO	MMODE0D01	;IF RDAD1 != 20 THEN MMODE0D01
/* RDAD1 == 20(RtBO[V)
/*  OR p H
BTFSC	MCON,	RB3	;IF MCON<3> == 0ipNOj THEN SKIP
GOTO	MMODE0D03	;IF MCON<3> == 1ipYESj THEN MMODE0D03
/* MCON<3> == 0ipNOj
BSF	MCON,	RB2	;MCON<2>=1iYESj
MOVLW	#13		;13 -> W
GOTO	MEND12		;NOT CLR,LOAD
/* MCON<3> == 1(pYES)
#LBL	MMODE0D03
MOVLW	#19		;19 -> W
GOTO	MEND12		;NOT CLR,LOAD
/* RDAD1 != 20iRtBO[Vj
#LBL	MMODE0D01
/*  OR p H
BTFSC	MCON,	RB1	;IF MCON<1> == 0ipNOj THEN SKIP
GOTO	MMODE0D05	;IF MCON<1> == 1ipYESj THEN MMODE0D05
/* MCON<1> == 0ipNOj
BSF	MCON,	RB0	;MCON<0>=1iYESj
GOTO	MEND11		;NOT CLR,INC
/* MCON<1> == 1ipYESj
#LBL	MMODE0D05
MOVLW	#19		;19 -> W
GOTO	MEND12		;NOT CLR,LOAD

/* MMODE == 0E _~[f[^̗p ------------------------------------
#LBL	MMODE0E
BCF	PORTA,	RA2	;+12V OFF
CLRF	SBYTE0		;_~[f[^쐬
CLRF	SBYTE1
BSF	PORTA,	RA2	;+12V ON
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 0F LOAD DATA COMMAND -------------------------------------
#LBL	MMODE0F
BCF	SENDC,	RB2	;COMMAND
MOVLW	LDPM		;LOAD DATA FOR PROG. MEM.
CALL	SDATA
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 10 f[^ ʂWrbg ----------------------------
#LBL	MMODE10
MOVF	SBYTE0,	WREG	;SBYTE0 -> W
BSF	SENDC,	RB2	;DATA
CALL	SDATA
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 11 f[^ ʂWrbg ----------------------------
#LBL	MMODE11
MOVF	SBYTE1,	WREG	;SBYTE0 -> W
CALL	SDATA
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 12 ZbgI ---------------------------------------------
#LBL	MMODE12
CLRF	ADCNT1		;ADDRES COUNTER1 CLR
CLRF	ADCNT0		;ADDRES COUNTER0 CLR
CLRF	MCON		;MCON CLR
BSF	MCON,	RB1	;MCON<1>=1ipYESj
/* PMAX SET
MOVLW	#19		;19h(25) -> W
MOVWF	PMAX		;W -> PMAX
MOVLW	#19		;19 -> W
GOTO	MEND12		;NOT CLR,LOAD

/* MMODE == 14 LOAD CONFIGURATION COMMAND -----------------------------
#LBL	MMODE14
BCF	SENDC,	RB2	;COMMAND
MOVLW	LCREG		;LOAD CONFIGURATION
CALL	SDATA
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 17 ZbgI ---------------------------------------------
#LBL	MMODE17
MOVLW	#20		;20 -> W
MOVWF	ADCNT1		;ADDRES COUNTER1 SET
CLRF	ADCNT0		;ADDRES COUNTER0 CLR
CLRF	MCON		;MCON CLR
BSF	MCON,	RB3	;MCON<3>=1ipYESj
/* PMAX SET
MOVLW	#64		;64h(100) -> W
MOVWF	PMAX		;W -> PMAX
MOVLW	#19		;19 -> W
GOTO	MEND12		;NOT CLR,LOAD

/* MMODE == 18 I ----------------------------------------------
#LBL	MMODE18
CLRF	MCON		;MCON CLR
MOVLW	#32		;32 -> W
GOTO	MEND12		;NOT CLR,LOAD

/* MMODE == 19 AhXXLbv --------------------------------------
#LBL	MMODE19
MOVF	ADCNT0,	WREG	;ADCNT0 -> W
SUBWF	RDAD0,	WREG	;RDAD0 - W -> W
BTFSS	STATUS,	ZERO	;IF ADCNT0 == RDAD0 THEN SKIP
GOTO	MMODE1401	;IF ADCNT0 != RDAD0 THEN MMODE1401
/* ADCNT0 == RDAD0
MOVF	ADCNT1,	WREG	;ADCNT1 -> W
SUBWF	RDAD1,	WREG	;RDAD1 - W -> W
BTFSC	STATUS,	ZERO	;IF ADCNT1 != RDAD1 THEN SKIP
GOTO	MEND11		;IF ADCNT1 == RDAD1 THEN MEND11(NOT CLR,INC)
/* AhXXLbv
#LBL	MMODE1401
MOVLW	INCAD		;INC. AD. COMMAND
BCF	SENDC,	RB2	;0=COMMAND
CALL	SDATA		;SEND COMMAND
INCFSZ	ADCNT0,	BACK	;ADCNT0 + 1 -> ADCNT0 , IF ADCNT0 == 0 THEN SKIP
GOTO	MEND10		;NOT CLR,NOT INC
INCF	ADCNT1,	BACK	;IF ADCNT0 == 0 THEN ADCNT1 + 1 -> ADCNT1
GOTO	MEND10		;NOT CLR,NOT INC

/* MMODE == 1A DATA PڎM --------------------------------------
#LBL	MMODE1A
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
MOVWF	SBYTE0		;W -> SBYTE0
SWAPF	SBYTE0,	BACK	;SBYTE0<3:0> -> SBYTE0<7:4>,SBYTE0<7:4> -> SBYTE0<3:0>
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 1B DATA QڎM --------------------------------------
#LBL	MMODE1B
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
IORWF	SBYTE0,	BACK	;SBYTE0 OR W -> SBYTE0
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 1C DATA RڎM --------------------------------------
#LBL	MMODE1C
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
MOVWF	SBYTE1		;W -> SBYTE1
SWAPF	SBYTE1,	BACK	;SBYTE1<3:0> -> SBYTE1<7:4>,SBYTE1<7:4> -> SBYTE1<3:0>
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 1D DATA SڎM --------------------------------------
#LBL	MMODE1D
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
CALL	CHEX		;ASCII -> BIN(W)
IORWF	SBYTE1,	BACK	;SBYTE1 OR W -> SBYTE1
/* f[^Vtg
BCF	STATUS,	CARY	;CARY CLR
RLF	SBYTE0,	BACK	;CARY -> SBYTE0<0> , SBYTE0<7> -> CARY
RLF	SBYTE1,	BACK	;CARY -> SBYTE1<0> , SBYTE1<7> -> CARY
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 1E ݉񐔂̏ -----------------------------------
#LBL	MMODE1E
/* SBYTE1 CHECK
MOVF	SBYTE1,	WREG	;SBYTE1 -> W
SUBLW	#7F		;#7F - W -> W
BTFSS	STATUS,	ZERO	;IF SBYTE1 == #7F THEN SKIP
GOTO	MMODE1E01	;IF SBYTE1 != #7F THEN MMODE1E01
/* SBYTE1 == #7F
MOVF	SBYTE0,	WREG	;SBYTE0 -> W
SUBLW	#FE		;#FE - W -> W
BTFSS	STATUS,	ZERO	;IF SBYTE1 == #FE THEN SKIP
GOTO	MMODE1E01	;IF SBYTE1 != #FE THEN MMODE1E01
/* SBYTE0 == #FE
MOVLW	#31		;#31 -> W
MOVWF	MMODE		;W -> MMODE
GOTO	MEND12		;NOT CLR,LOAD
/* SBYTE0 != #FE AND SBYTE1 != #7F
#LBL	MMODE1E01
CLRF	PCNT		;0 -> PCNT
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 22 BEGIN / END PROGRAMMING COMMAND ------------------------
#LBL	MMODE22
/* TMR0 =< &H30 ?
MOVF	TMR0,	WREG	;TMR0 -> W
SUBLW	#30		;#30 - W -> W
BTFSS	STATUS,	CARY	;IF CARY == 1(#30 >= TMR0) THEN SKIP
GOTO	MEND10		;IF (#30 - W) >= 0 THEN MEND10(NOT CLR,NOT INC)
/* TMR0 =< &H30
MOVF	TMR0,	WREG	;TMR0 -> W
MOVWF	STMR0		:W -> STMR0
/* BIGIN PRG. COMMAND
BCF	SENDC,	RB2	;COMMAND
MOVLW	BEGINP		;BEGIN PROGRAMING
CALL	SDATA
/* 100us WAIT
MOVF	STMR0,	WREG	;STMR0 -> W
ANDLW	#80		;#80 + W -> W
MOVWF	STMR0		;W -> STMR0
/* TMR0 CHECK
#LBL	MMODE2201
MOVF	TMR0,	WREG	;TMR0 -> W
SUBWF	STMR0,	WREG	;STMR0 - W -> W
BTFSC	STATUS,	CARY	;IF CARY == 0(STMR0 < TMR0) THEN SKIP
GOTO	MMODE2201	;IF (STMR0 >= TMR0) THEN MMODE2201
/* END PRG. COMMAND
BCF	SENDC,	RB2	;COMMAND
MOVLW	ENDP		;END PROGRAMING
CALL	SDATA
INCF	MMODE,	BACK	;MMODE + 1 -> MMODE
INCF	MMODE,	BACK	;MMODE + 1 -> MMODE
INCF	MMODE,	BACK	;MMODE + 1 -> MMODE
GOTO	MEND10		;NOT CLR,NOT INC

/* MMODE == 23 NOT USE ------------------------------------------------

/* MMODE == 24 NOT USE ------------------------------------------------

/* MMODE == 25 f[^ǂݍ݃R}h -------------------------------
#LBL	MMODE25
BCF	SENDC,	RB2	;COMMAND
BCF	SENDC,	RB4	;WRITE ERROR =0(NO)
MOVLW	RDPM		;ROAD DATA FOR PROG. MEM.
CALL	SDATA
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 26 f[^ǂݍ ʂWrbg -----------------------------
#LBL	MMODE26
/* BANK 1
BSF	STATUS,	RP0	;BANK 1
BSF	TRISA,	RA1	;RA1 IS INPUT(DATA)
/* BANK 0
BCF	STATUS,	RP0	;BANK 0
CALL	RDATA		;READ DATA -> W
ANDLW	#FE		;FE(1111 1110) AND W -> W
SUBWF	SBYTE0,	WREG	;SBYTE0 - W -> W
BTFSS	STATUS,	ZERO	;IF SBYTE0 == W THEN SKIP
BSF	SENDC,	RB4	;WRITE ERROR =1(YES)
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 27 f[^ǂݍ ʂWrbg -----------------------------
#LBL	MMODE27
CALL	RDATA		;READ DATA -> W
ANDLW	#7F		;7F(0111 1111) AND W -> W
SUBWF	SBYTE1,	WREG	;SBYTE1 - W -> W
BTFSS	STATUS,	ZERO	;IF SBYTE1 == W THEN SKIP
BSF	SENDC,	RB4	;WRITE ERROR =1(YES)
/* BANK 1
BSF	STATUS,	RP0	;BANK 1
BCF	TRISA,	RA1	;RA1 IS OUTPUT(DATA)
/* BANK 0
BCF	STATUS,	RP0	;BANK 0
BCF	PORTA,	RA1	;DATA PORT CLR
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 28 r --------------------------------------------------
#LBL	MMODE28
INCF	PCNT,	BACK	;PCNT + 1 -> PCNT
BTFSS	SENDC,	RB4	;IF WRITE ERROR == 1 THEN SKIP
GOTO	MMODE2801
/* WRITE ERROR == 1
MOVF	PMAX,	WREG	;PMAX -> W
SUBWF	PCNT,	WREG	;PCNT - W -> W
BTFSS	STATUS,	ZERO	;IF ZERO == 1 THEN SKIP
GOTO	MMODE2802	;IF ZERO == 0 THEN MMODE2802
/* PMAX == PCNT(WRITE ERROR!!!)
BCF	SENDC,	RB4	;WRITE ERROR = 0
MOVLW	#39		;39 -> W
GOTO	MEND12		;NOT CLR,LOAD
/* PMAX > PCNT
#LBL	MMODE2802
BCF	SENDC,	RB4	;WRITE ERROR = 0
MOVLW	#1F		;1F -> W
GOTO	MEND12		;NOT CLR,LOAD
/* WRITE ERROR == 0
#LBL	MMODE2801
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 29 ǉ݉񐔂̏ -------------------------------
#LBL	MMODE29
CLRF	APCNT1		;ǉ݉񐔂̃NA
MOVF	PCNT,	WREG	;PCNT -> W
MOVWF	APCNT0		;W -> APCNT0
ADDWF	APCNT0,	BACK	;APCNT0 + W -> APCNT0
BTFSC	STATUS,	CARY	;IF CARY == 0 THEN SKIP
INCF	APCNT1,	BACK	;IF CARY == 1 THEN APCNT1 ++
ADDWF	APCNT0,	BACK	;APCNT0 + W -> APCNT0
BTFSC	STATUS,	CARY	;IF CARY == 0 THEN SKIP
INCF	APCNT1,	BACK	;IF CARY == 1 THEN APCNT1 ++
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 30 ݉񐔃`FbN -----------------------------------
#LBL	MMODE30
/* APCNT0 CHECK
MOVF	APCNT0,	WREG	;APCNT0 -> W
BTFSS	STATUS,	ZERO	;IF APCNT0 == 0 THEN SKIP
GOTO	MMODE3001	;IF APCNT0 != 0 THEN MMODE3001
/* APCNT0 == 0
DECF	APCNT1,	BACK	;APCNT1 - 1 -> APCNT1
DECF	APCNT0,	BACK	;FF -> APCNT0
/* LOOP
#LBL	MMODE3002
MOVLW	#2A		;2A -> W
GOTO	MEND12		;NOT CLR,LOAD
/* APCNT0 != 0
#LBL	MMODE3001
DECFSZ	APCNT0,	BACK	;APCNT0 - 1 -> APCNT0, IF APCNT0 == 0 THEN SKIP
GOTO	MMODE3002	;IF APCNT0 != 0 THEN MMODE3002
/* APCNT0 == 0
MOVF	APCNT1,	WREG	;APCNT1 -> W
BTFSS	STATUS,	ZERO	;IF APCNT1 == 0 THEN SKIP
GOTO	MMODE3002	;IF APCNT1 != 0 THEN MMODE3002
/* APCNT0 == 0 AND APCNT1 == 0
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 31 DLOP`FbN -------------------------------------------
#LBL	MMODE31
DECFSZ	DLOP,	BACK	;DLOP - 1 -> DLOP,IF DLOP == 0 THEN SKIP
GOTO	MMODE3101
/* DLOP == 0
MOVLW	#32		;32 -> W
GOTO	MEND12		;NOT CLR,LOAD
/* DLOP != 0
#LBL	MMODE3101
MOVLW	#36		;36 -> W
GOTO	MEND12		;NOT CLR,LOAD

/* MMODE == 32 CHK SUM PڎM ---------------------------------
#LBL	MMODE32
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF

/* MMODE == 33 CHK SUM QڎM ---------------------------------
#LBL	MMODE33
MOVF	RDTMP,	WREG	;RDTMP -> W
/* RDTMP == 0 ?
BTFSC	STATUS,	ZERO	;IF RDTMP != 0 THEN SKIP
GOTO	MEND00		;IF RDTMP == 0 THEN MEND00(CLR,NOT INC)
/* RDTMP != 0
/* EOF CHECK
BTFSS	SENDC,	RB7	;IF SENDC<7> == 1(EOF) THEN SKIP
GOTO	MEND03		;CLR,INC,RDTMP -> SDBUF
/* EOF
MOVLW	#37		;37 -> W
GOTO	MEND04		;CLR,LOAD,RDTMP -> SDBUF

/* MMODE == 35 ̃R[hM --------------------------------------
#LBL	MMODE35
MOVLW	#04		;04 -> W
GOTO	MEND12		;NOT CLR,LOAD

/* MMODE == 36 DATA pM -----------------------------------------
#LBL	MMODE36
/* READ ADDRES COUNTER UP
INCFSZ	RDAD0,	BACK	;RDAD0 + 1 -> RDAD0,IF RDAD0 == 0 THEN SKIP
GOTO	MMODE3603
INCF	RDAD1,	BACK	;RDAD1 + 1 -> RDAD1
#LBL	MMODE3603
MOVLW	#19		;19 -> W
GOTO	MEND12		;NOT CLR,LOAD

/* MMODE == 38 f[^I --------------------------------------------
#LBL	MMODE38
MOVLW	#02		;02 -> W
GOTO	MEND12		;NOT CLR,LOAD

/* MMODE == 39 ݃G[ (CR)'Write ERROR'(CR)
/*				LN^[MJE^(CNT)Zbg
#LBL	MMODE39
MOVLW	#1A		;1A -> W
MOVWF	CSCNT		;W -> CHAR SEND CNT
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 3C vOǂ݂ --------------------------
#LBL	MMODE3C
BSF	PORTA,	RA2	;+12V ON
CLRF	ADCNT0		;ADDRES COUNTER0 CLR
CLRF	ADCNT1		;ADDRES COUNTER1 CLR
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 3D (CR)':10' LN^[MJE^(CNT)Zbg ---------
#LBL	MMODE3D
MOVLW	#10		;10 -> W
MOVWF	CSUM		;W -> CSUM
MOVLW	#28		;28 -> W
MOVWF	CSCNT		;W -> CHAR SEND CNT
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 3F AhXPڑM ----------------------------------
#LBL	MMODE3F
SWAPF	ADCNT1,	WREG	;ADCNT1<7:4> <-> ADCNT1<3:0> -> W
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 40 AhXQڑM ----------------------------------
#LBL	MMODE40
MOVF	ADCNT1,	WREG	;ADCNT1 -> W
ADDWF	CSUM,	BACK	;CSUM + W -> CSUM
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 41 AhXRڑM ----------------------------------
#LBL	MMODE41
SWAPF	ADCNT0,	WREG	;ADCNT0 -> W
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 42 AhXSڑM ----------------------------------
#LBL	MMODE42
MOVF	ADCNT0,	WREG	;ADCNT0 -> W
ADDWF	CSUM,	BACK	;CSUM + W -> CSUM
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 43 '0'M -----------------------------------------------
#LBL	MMODE43
MOVLW	#30		;30('0') -> W
GOTO	MEND15		;NOT CLR,INC,W -> SDBUF

/* MMODE == 45 f[^PڑM ------------------------------------
#LBL	MMODE45
BCF	SENDC,	RB2	;COMMAND
MOVLW	RDPM		;ROAD DATA FOR PROG. MEM.
#LBL	MMODE4501
CALL	SDATA
/* BANK 1
BSF	STATUS,	RP0	;BANK 1
BSF	TRISA,	RA1	;RA1 IS INPUT(DATA)
/* BANK 0
BCF	STATUS,	RP0	;BANK 0
/* ʂWrbgǂݏo
CALL	RDATA		;READ DATA -> W
MOVWF	SBYTE0		;W -> SBYTE0
/* ʂWrbgǂݏo
CALL	RDATA		;READ DATA -> W
MOVWF	SBYTE1		;W -> SBYTE1
/* rbgVtg
BCF	STATUS,	CARY	;CARY CLR
RRF	SBYTE1,	BACK	;CARY -> SBYTE1<7> , SBYTE1<0> -> CARY
RRF	SBYTE0,	BACK	;CARY -> SBYTE0<7> , SBYTE0<0> -> CARY
SWAPF	SBYTE0,	WREG	;SBYTE0<7:4> <-> SBYTE0<3:0> -> W
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 46 f[^QڑM ----------------------------------
#LBL	MMODE46
/* BANK 1
BSF	STATUS,	RP0	;BANK 1
BCF	TRISA,	RA1	;RA1 IS OUTPUT(DATA)
/* BANK 0
BCF	STATUS,	RP0	;BANK 0
BCF	PORTA,	RA1	;DATA PORT CLR
MOVF	SBYTE0,	WREG	;SBYTE0 -> W
ADDWF	CSUM,	BACK	;CSUM + W -> CSUM
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 47 f[^RڑM ----------------------------------
#LBL	MMODE47
SWAPF	SBYTE1,	WREG	;SBYTE1<7:4> <-> SBYTE1<3:0> -> W
ANDLW	#03		;03(0000 0011) AND W -> W
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 48 f[^SڑM ----------------------------------
#LBL	MMODE48
MOVF	SBYTE1,	WREG	;SBYTE1 -> W
ANDLW	#3F		;3F(0011 1111) -> W
ADDWF	CSUM,	BACK	;CSUM + W -> CSUM
MOVF	SBYTE1,	WREG	;SBYTE1 -> W
ANDLW	#0F		;0F(0000 1111) AND W -> W
CALL	BINASC		;BIN -> ASCII(W)
MOVWF	SDBUF		;W -> SDBUF
/* AhXCNg
BCF	SENDC,	RB2	;COMMAND
MOVLW	INCAD		;INCREMENT ADDRES
CALL	SDATA
MOVLW	#02		;02 -> W
ADDWF	ADCNT0,	BACK	;ADCNT0 + W -> ADCNT0
BTFSC	STATUS,	CARY	;IF CARY == 0 THEN SKIP
INCF	ADCNT1,	BACK	;IF CARY == 1 THEN ADCNT1 + 1 -> ADCNT1
/* R[hIH
MOVF	ADCNT0,	WREG	;ADCNT0 -> W
ANDLW	#0F		;0F(0000 1111) AND W -> W
BTFSC	STATUS,	ZERO	;IF ADCNT0<3:0> != 0 THEN SKIP
GOTO	MEND11		;NOT CLR,INC
/* ADCNT0<3:0> != 0
DECF	MMODE,	BACK	;MMODE - 1 -> MMODE
DECF	MMODE,	BACK	;MMODE - 1 -> MMODE
DECF	MMODE,	BACK	;MMODE - 1 -> MMODE
GOTO	MEND10		;NOT CLR,NOT INC

/* MMODE == 49 `FbNrtlPڑM ----------------------------
#LBL	MMODE49
MOVF	CSUM,	WREG	;CSUM -> W
SUBLW	#00		;00 - W -> W
MOVWF	CSUM		;W -> CSUM
SWAPF	CSUM,	WREG	;CSUM<7:4> <-> CSUM<3:> -> W
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 4A `FbNrtlQڑM ----------------------------
#LBL	MMODE4A
MOVF	CSUM,	WREG
GOTO	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF

/* MMODE == 4B I ----------------------------------------------
#LBL	MMODE4B
/* vOIH
MOVF	RADMAX,	WREG	;RADMAX -> W
SUBWF	ADCNT1,	WREG	;ADCNT1 - W -> W
BTFSC	STATUS,	ZERO	;IF ADNCT1 != RADMAX THEN SKIP
GOTO	MEND11		;NOT CLR,INC
/* ADCNT1 != RADMAX
MOVLW	#3D		;3D -> W
MOVWF	MMODE		;W -> MMODE
GOTO	MEND10		;NOT CLR,NOT INC

/* MMODE == 4C RtBO[Vǂ݂ ----------------
#LBL	MMODE4C
CLRF	ADCNT0		;ADCNT0 CLR
MOVLW	#40		;40 -> W
MOVWF	ADCNT1		;W -> ADCNT1
BCF	SENDC,	RB2	;COMMAND
MOVLW	LCREG		;LOAD CONFIGURATION REG.
CALL	SDATA
MOVLW	#00		;00 -> W
BSF	SENDC,	RB2	;DATA
CALL	SDATA
MOVLW	#00		;00 -> W
CALL	SDATA
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 5B I ----------------------------------------------
#LBL	MMODE5B
/* vOIH
BCF	PORTA,	RA2	;+12V OFF
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 5C '(CR):00000001FF(CR)' ---------------------------------
/*				LN^[MJE^(CNT)Zbg
#LBL	MMODE5C
MOVLW	#2D		;2D -> W
MOVWF	CSCNT		;W -> CHAR SEND CNT
GOTO	MEND11		;NOT CLR,INC

/* MMODE == 5E I -----------------------------------------------
#LBL	MMODE5E
MOVLW	#02		;02 -> W
MOVWF	MMODE		;W -> MMODE
GOTO	MEND10		;NOT CLR,NOT INC

/* MEND --------------------------------------------------------------
#LBL	MEND03		;CLR,INC,RDTMP -> SDBUF
MOVF	RDTMP,	WREG	;RDTMP -> W
MOVWF	SDBUF		;W -> SDBUF
#LBL	MEND01		;CLR,INC
INCF	MMODE,	BACK	;MMODE + 1 -> MMODE
#LBL	MEND00		;CLR,NOT INC
CLRF	RDTMP		;RDTMP CLR
BCF	SENDC,	RB5	;RDTMP CLR
RETFIE			;RETURN FROM INTERRUPT

#LBL	MEND13		;NOT CLR,INC,W -> ASCII -> SDBUF
ANDLW	#0F		;0F(0000 1111) AND W -> W
CALL	BINASC		;BIN -> ASCII(W)
#LBL	MEND15		;NOT CLR,INC,W -> SDBUF
MOVWF	SDBUF		;W -> SDBUF
#LBL	MEND11		;NOT CLR,INC
INCF	MMODE,	BACK	;MMODE + 1 -> MMODE
#LBL	MEND10		;NOT CLR,NOT INC
RETFIE			;RETURN FROM INTERRUPT

#LBL	MEND04		;CLR,LOAD,RDTMP -> SDBUF
MOVWF	MMODE		;W -> MMODE
MOVF	RDTMP,	WREG	;RDTMP -> W
MOVWF	SDBUF		;W -> SDBUF
CLRF	RDTMP		;RDTMP CLR
BCF	SENDC,	RB5	;RDTMP CLR
RETFIE			;RETURN FROM INTERRUPT

#LBL	MEND02		;CLR,LOAD
CLRF	RDTMP		;RDTMP CLR
BCF	SENDC,	RB5	;RDTMP CLR
#LBL	MEND12		;NOT CLR,LOAD
MOVWF	MMODE		;W -> MMODE
RETFIE			;RETURN FROM INTERRUPT

/* BUF PUT SUB. ------------------------------------------------------
#LBL	BUFPUT
MOVF	RDBUF0,	BACK	;RDBUF0 CHECK
BTFSS	STATUS,	ZERO	;IF RDBUF0 == 0 THEN SKIP
GOTO	BP01		;IF RDBUF0 != 0 THEN BP01
/* RDBUF0 == 0
MOVWF	RDBUF0		;W -> RDBUF0
RETURN
/* RDBUF0 != 0
#LBL	BP01
MOVF	RDBUF1,	BACK	;RDBUF1 CHECK
BTFSS	STATUS,	ZERO	;IF RDBUF1 == 0 THEN SKIP
GOTO	BP02		;IF RDBUF1 != 0 THEN BP02
/* RDBUF1 == 0
MOVWF	RDBUF1		;W -> RDBUF1
RETURN
/* RDBUF1 != 0
#LBL	BP02
MOVF	RDBUF2,	BACK	;RDBUF2 CHECK
BTFSS	STATUS,	ZERO	;IF RDBUF2 == 0 THEN SKIP
GOTO	BP03		;IF RDBUF2 != 0 THEN BP03
/* RDBUF2 == 0
MOVWF	RDBUF2		;W -> RDBUF2
RETURN
/* RDBUF2 != 0
#LBL	BP03
MOVF	RDBUF3,	BACK	;RDBUF3 CHECK
BTFSS	STATUS,	ZERO	;IF RDBUF3 == 0 THEN SKIP
GOTO	BP04		;IF RDBUF3 != 0 THEN BP04
/* RDBUF3 == 0
MOVWF	RDBUF3		;W -> RDBUF3
RETURN
/* RDBUF3 != 0
#LBL	BP04
MOVF	RDBUF4,	BACK	;RDBUF4 CHECK
BTFSS	STATUS,	ZERO	;IF RDBUF4 == 0 THEN SKIP
GOTO	BP05		;IF RDBUF4 != 0 THEN BP05
/* RDBUF4 == 0
MOVWF	RDBUF4		;W -> RDBUF4
RETURN
/* RDBUF4 != 0
#LBL	BP05
MOVF	RDBUF5,	BACK	;RDBUF5 CHECK
BTFSS	STATUS,	ZERO	;IF RDBUF5 == 0 THEN SKIP
GOTO	BP06		;IF RDBUF5 != 0 THEN BP06
/* RDBUF5 == 0
MOVWF	RDBUF5		;W -> RDBUF5
RETURN
/* RDBUF5 != 0
#LBL	BP06
MOVF	RDBUF6,	BACK	;RDBUF6 CHECK
BTFSS	STATUS,	ZERO	;IF RDBUF6 == 0 THEN SKIP
GOTO	BP07		;IF RDBUF6 != 0 THEN BP07
/* RDBUF6 == 0
MOVWF	RDBUF6		;W -> RDBUF5
RETURN
/* RDBUF6 != 0
#LBL	BP07
MOVWF	RDBUF7		;W -> RDBUF7
RETURN

/* BUF GET SUB. ------------------------------------------------------
#LBL	BUFGET
BTFSC	SENDC,	RB0	;IF XOFF MODE == 0(OFF) THEN SKIP
GOTO	BG02		;IF XOFF MODE == 1(ON) THEN BG02
/* MODE == 0(OFF)
MOVF	RDBUF3,	BACK	;RDBUF3 CHECK
BTFSC	STATUS,	ZERO	;IF RDBUF3 != 0 THEN SKIP
GOTO	BG01		;IF RDBUF3 == 0 THEN BG01
/* REBUF3 != 0
/* XOFF MODE=0(OFF) -> 1(ON)
BSF	SENDC,	RB0	;XOFF MODE=1(ON)
MOVLW	XOFFC		;XOFF CODE -> W
RETURN
/* XOFF MODE == ON
#LBL	BG02
MOVF	RDBUF0,	BACK	;RDBUF0 CHECK
BTFSS	STATUS,	ZERO	;IF RDBUF0 == 0 THEN SKIP
GOTO	BG01		;IF RDBUF0 != 0 THEN BG01
/* RDBUF0 == 0(BUF NULL) XMODE=1(ON) -> 0(OFF)
BCF	SENDC,	RB0	;XOFF MODE=0
MOVLW	XONC		;XON CODE -> W
RETURN
/*
#LBL	BG01
MOVF	RDBUF0,	WREG	;RDBUF0 -> W
BTFSC	STATUS,	ZERO	;IF RDBUF0 != 0 THEN SKIP
RETURN			;IF RDBUF0 == 0 THEN RETURN
/* RDBUF != 0
MOVWF	TMPREG		;W -> TMPREG
MOVF	RDBUF1,	WREG	;RDBUF1 -> W
MOVWF	RDBUF0		;W -> RDBUF0
MOVF	RDBUF2,	WREG	;RDBUF2 -> W
MOVWF	RDBUF1		;W -> RDBUF1
MOVF	RDBUF3,	WREG	;RDBUF3 -> W
MOVWF	RDBUF2		;W -> RDBUF2
MOVF	RDBUF4,	WREG	;RDBUF4 -> W
MOVWF	RDBUF3		;W -> RDBUF3
MOVF	RDBUF5,	WREG	;RDBUF5 -> W
MOVWF	RDBUF4		;W -> RDBUF4
MOVF	RDBUF6,	WREG	;RDBUF6 -> W
MOVWF	RDBUF5		;W -> RDBUF5
MOVF	RDBUF7,	WREG	;RDBUF7 -> W
MOVWF	RDBUF6		;W -> RDBUF6
CLRF	RDBUF7		;RDBUF7 CLR
MOVF	TMPREG,	WREG	;TMPREG -> W
RETURN

/* CHAR HEX CORD CHEK SUB. -------------------------------------------
#LBL	CHEX
MOVWF	TMPREG		;W -> TMPREG
MOVLW	#3A		;3A('9'+1) -> W
SUBWF	TMPREG,	WREG	;TMPREG - W -> W
BTFSC	STATUS,	CARY	;IF TMPREG < 3A('9'+1) THEN SKIP
GOTO	CHEXAF		;IF TMPREG >= 3A('9'+1) THEN CHEXAF
/* CHAR 0 TO 9
MOVLW	#30		;30('0') -> W
SUBWF	TMPREG,	WREG	;TMPREG - W -> W
RETURN
/* CHEXAF
#LBL	CHEXAF
MOVLW	#37		;37('A' - 0A) -> W
SUBWF	TMPREG,	WREG	;TMPREG - W -> W
RETURN

/* SDATA --------------------------------------------------------------
#LBL	SDATA
MOVWF	TMPREG		;W -> TMPREG
/* 0 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BTFSC	TMPREG,	RB0	;IF TMPREG<0> == 0 THEN SKIP
BSF	PORTA,	RA1	;DATA OUT
BCF	PORTA,	RA0	;CLOCK LOW
/* 1 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BTFSC	TMPREG,	RB1	;IF TMPREG<1> == 0 THEN SKIP
BSF	PORTA,	RA1
BTFSS	TMPREG,	RB1	;IF TMPREG<1> == 1 THEN SKIP
BCF	PORTA,	RA1
BCF	PORTA,	RA0	;CLOCK LOW
/* 2 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BTFSC	TMPREG,	RB2	;IF TMPREG<2> == 0 THEN SKIP
BSF	PORTA,	RA1
BTFSS	TMPREG,	RB2	;IF TMPREG<2> == 1 THEN SKIP
BCF	PORTA,	RA1
BCF	PORTA,	RA0	;CLOCK LOW
/* 3 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BTFSC	TMPREG,	RB3	;IF TMPREG<3> == 0 THEN SKIP
BSF	PORTA,	RA1
BTFSS	TMPREG,	RB3	;IF TMPREG<3> == 1 THEN SKIP
BCF	PORTA,	RA1
BCF	PORTA,	RA0	;CLOCK LOW
/* 4 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BTFSC	TMPREG,	RB4	;IF TMPREG<4> == 0 THEN SKIP
BSF	PORTA,	RA1
BTFSS	TMPREG,	RB4	;IF TMPREG<4> == 1 THEN SKIP
BCF	PORTA,	RA1
BCF	PORTA,	RA0	;CLOCK LOW
/* 5 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BTFSC	TMPREG,	RB5	;IF TMPREG<5> == 0 THEN SKIP
BSF	PORTA,	RA1
BTFSS	TMPREG,	RB5	;IF TMPREG<5> == 1 THEN SKIP
BCF	PORTA,	RA1
BCF	PORTA,	RA0	;CLOCK LOW
/*
BTFSC	SENDC,	RB2	;IF COMMAND THEN SKIP
GOTO	SDATA01		;IF DATA THEN SDATA01
/* COMMAND
BCF	PORTA,	RA1	;DATA LOW
RETURN
/* DATA
#LBL	SDATA01
/* 6 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BTFSC	TMPREG,	RB6	;IF TMPREG<6> == 0 THEN SKIP
BSF	PORTA,	RA1
BTFSS	TMPREG,	RB6	;IF TMPREG<6> == 1 THEN SKIP
BCF	PORTA,	RA1
BCF	PORTA,	RA0	;CLOCK LOW
/* 7 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BTFSC	TMPREG,	RB7	;IF TMPREG<7> == 0 THEN SKIP
BSF	PORTA,	RA1
BTFSS	TMPREG,	RB7	;IF TMPREG<7> == 1 THEN SKIP
BCF	PORTA,	RA1
BCF	PORTA,	RA0	;CLOCK LOW
/*
BCF	PORTA,	RA1	;DATA LOW
RETURN

/* RDATA --------------------------------------------------------------
#LBL	RDATA
CLRF	TMPREG		;TMPREG CLR
/* 0 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BCF	PORTA,	RA0	;CLOCK LOW
BTFSC	PORTA,	RA1	;IF DATA == 0 THEN SKIP
BSF	TMPREG,	RB0	;DATA 0bit SET
/* 1 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BCF	PORTA,	RA0	;CLOCK LOW
BTFSC	PORTA,	RA1	;IF DATA == 0 THEN SKIP
BSF	TMPREG,	RB1	;DATA 1bit SET
/* 2 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BCF	PORTA,	RA0	;CLOCK LOW
BTFSC	PORTA,	RA1	;IF DATA == 0 THEN SKIP
BSF	TMPREG,	RB2	;DATA 2bit SET
/* 3 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BCF	PORTA,	RA0	;CLOCK LOW
BTFSC	PORTA,	RA1	;IF DATA == 0 THEN SKIP
BSF	TMPREG,	RB3	;DATA 3bit SET
/* 4 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BCF	PORTA,	RA0	;CLOCK LOW
BTFSC	PORTA,	RA1	;IF DATA == 0 THEN SKIP
BSF	TMPREG,	RB4	;DATA 4bit SET
/* 5 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BCF	PORTA,	RA0	;CLOCK LOW
BTFSC	PORTA,	RA1	;IF DATA == 0 THEN SKIP
BSF	TMPREG,	RB5	;DATA 5bit SET
/* 6 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BCF	PORTA,	RA0	;CLOCK LOW
BTFSC	PORTA,	RA1	;IF DATA == 0 THEN SKIP
BSF	TMPREG,	RB6	;DATA 6bit SET
/* 7 bit
BSF	PORTA,	RA0	;CLOCK HIGH
BCF	PORTA,	RA0	;CLOCK LOW
BTFSC	PORTA,	RA1	;IF DATA == 0 THEN SKIP
BSF	TMPREG,	RB7	;DATA 7bit SET
/*
MOVF	TMPREG,	WREG	;TMPREG -> W
RETURN
